\documentclass[10pt,a4paper]{report}
\usepackage[top=3cm, bottom=2.5cm, left=3cm, right=2.5cm] {geometry}
\usepackage {bsymb,b2latex}
\usepackage[utf8]{inputenc}
\usepackage{fancyhdr,lastpage,color}
\lhead{\rm An Event-B Specification of m1}
\rhead {\rm Page \thepage~of \pageref{LastPage}}
\lfoot{}\cfoot{}\rfoot{}
\pagestyle{fancy}
%---------------------------------------------------------
\begin{document}
\thispagestyle{empty}
\begin{description}
\BTitle{m1}{11Dec2016}{09:45:08 PM}
\MACHINE{m1}
\SEES{c0}
\VARIABLES
	\begin{description}
		\Item{ y1 }
		\Item{ y2 }
		\Item{ y3 }
		\Item{ z }
		\Item{ pc }
	\end{description}
\INVARIANTS
	\begin{description}
		\nItem{ inv1 }{ y1 \in  \intg  }
		\nItem{ inv2 }{ y2 \in  \intg  }
		\nItem{ inv3 }{ y3 \in  \intg  }
		\nItem{ inv4 }{ z \in  \intg  }
		\nItem{ inv5 }{ pc \in  L  \land  (pc \neq  l0 \limp  y1\in \nat \land  y2\in \nat \land  y3\in \nat) }
		\nItem{ inv6 }{ pc = l0 \limp  y1\in \intg  \land  y2\in \intg  \land  y3\in \intg  \land  z\in \intg   }
		\nItem{ inv7 }{ pc = l1 \limp   y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land  y3* y1^y2 = x1^x2  }
		\nItem{ inv8 }{ pc = l2 \limp  y2\neq 0 \land  y3* y1^y2 = x1^x2 \land  y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  }
		\nItem{ inv9 }{ pc = l3 \limp    y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land  y2 mod 2\neq 0 \land  y2\neq 0 \land  y3* y1^y2=x1^x2  }
		\nItem{ inv10 }{ pc = l4 \limp   y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land   y2\geq 0 \land  y2 mod 2=0 \land  y3* y1* y1^y2=x1^x2 }
		\nItem{ inv11 }{ pc = l5 \limp   y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land   y2\geq 0 \land  y2 mod 2=0 \land  y3* y1^y2=x1^x2 }
		\nItem{ inv12 }{ pc = l6 \limp   y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land   y2\geq 0 \land  y2 mod 2=0 \land  y3* y1^y2=x1^x2 }
		\nItem{ inv13 }{ pc = l7 \limp   y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land   y2\geq 0 \land  y2 mod 2=0 \land  y3* y1^y2/ 2=x1^x2 }
		\nItem{ inv14 }{ pc = l8 \limp   y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land   y2\geq 0 \land  y3* y1^y2=x1^x2 }
		\nItem{ inv15 }{ pc = l9 \limp  y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land    y2=0 \land  y3* y1^y2=x1^x2 }
		\nItem{ inv16 }{ pc = l10 \limp  y2=0 \land  y3* y1^y2=x1^x2 \land  y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land  z=x1^x2 }
		\nItem{ pre }{ x1\in \nat_1 \land  x2\in \nat \land  y1\in \intg  \land  y2\in \intg  \land y3\in \intg  \land  z \in  \intg  \limp y1\in \intg  \land  y2\in \intg  \land y3\in \intg  \land  z \in  \intg   }
		\nItem{ post }{ y2=0 \land  y3* y1^y2=x1^x2 \land  y1\in \nat \land  y2\in \nat \land  y3\in \nat \land  z\in \intg  \land  z=x1^x2 \limp  z=x1^x2 }
	\end{description}
\EVENTS
	\INITIALISATION
		\begin{description}
		\BeginAct
			\begin{description}
			\nItem{ act1 }{ y1 :\in  \intg  }
			\nItem{ act2 }{ y2 :\in  \intg  }
			\nItem{ act3 }{ y3 :\in  \intg  }
			\nItem{ act4 }{ z :\in  \intg  }
			\nItem{ act5 }{ pc :=  l0 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el0l1}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l1 }
			\nItem{ act2 }{ y1, y2, y3 :|  (y1'=x1 \land  y2'=x2 \land  y3'=1) }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el1l2}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l1 }
			\nItem{ grd2 }{ y2 \neq  0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l2 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el2l3}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l2 }
			\nItem{ grd2 }{ y2 mod 2 \neq  0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l3 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el3l4}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l3 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l4 }
			\nItem{ act2 }{ y2 :=  y2 -  1 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el4l5}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l4 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l5 }
			\nItem{ act2 }{ y3 :=  y3* y1 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el5l6}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l5 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l6 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el2l6}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l2 }
			\nItem{ grd2 }{ y2 mod 2 = 0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l6 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el6l7}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l6 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l7 }
			\nItem{ act2 }{ y1 :=  y1* y1 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el7l8}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l7 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l8 }
			\nItem{ act2 }{ y2 :=  y2 /  2 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el8l2}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l8 }
			\nItem{ grd2 }{ y2 \neq  0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l2 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el8l9}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l8 }
			\nItem{ grd2 }{ y2 = 0 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l9 }
			\end{description}
		\EndAct
		\end{description}
	\EVT {el9l10}
		\begin{description}
		\WhenGrd
			\begin{description}
			\nItem{ grd1 }{ pc = l9 }
			\end{description}
		\ThenAct
			\begin{description}
			\nItem{ act1 }{ pc :=  l10 }
			\nItem{ act2 }{ z :=  y3 }
			\end{description}
		\EndAct
		\end{description}
\END
\end{description}
\end{document}
